###############################################################
###    IPG - IDSIA
###    Authors: L. Azzimonti, G. Corani
###    Reference: "Hierarchical Multinomial-Dirichlet model for the estimation of conditional probability tables",
###    Proceedings of 2017 IEEE International Conference on Data Mining (ICDM 2017)
###    Date: August 22, 2017
###
###    This code is for demostration purpose only
###    for licensing contact laura@idsia.ch
###    COPYRIGHT (C) 2017 IDSIA
###############################################################

compute_loglike_singleD=function(D,prob_array){
  logP=1
  for(i in 1:p){
    if(length(dag$nodes[[i]]$parents)==0){
      logP_temp=log(prob_array[[variables[i]]][as.numeric(D[variables[i]])])
    }else{
      stringa="logP_temp=log(prob_array[[variables[i]]][as.numeric(D[variables[i]])"
      for(j in 1:length(dag$nodes[[i]]$parents)){
        k=as.numeric(D[dag$nodes[[i]]$parents[j]])
        stringa=paste(stringa, k, sep=",")
      }
      stringa=paste(stringa, "])", sep="")
      eval(parse(text=stringa))
    }
    logP=logP+logP_temp
  }
  return(logP)
}


compute_loglike=function(dati_test,prob_array){
logP=NULL
logPtot=1
for(Drow in 1:(dim(dati_test)[1])){
  D=dati_test[Drow,]
  logPtemp=compute_loglike_singleD(D,prob_array)
  logP=c(logP,logPtemp)
  logPtot=logPtot+logPtemp
}
return(list(logP=logPtot, logPvec=as.numeric(logP)))
}
