###############################################################
###    IPG - IDSIA
###    Authors: L. Azzimonti, G. Corani
###    Reference: "Hierarchical Multinomial-Dirichlet model for the estimation of conditional probability tables",
###    Proceedings of 2017 IEEE International Conference on Data Mining (ICDM 2017)
###    Date: August 22, 2017
###
###    This code is for demostration purpose only
###    for licensing contact laura@idsia.ch
###    COPYRIGHT (C) 2017 IDSIA
###############################################################

convert2array=function(theta,meaning_zStates,dati,variables,dag,I,J){

dimvec=length(levels(as.factor(dati[,variables[i]])))
dimnames = list(levels(as.factor(dati[,variables[i]])))
  
for(parent in dag$nodes[[i]]$parents){
  dimvec=c(dimvec,length(levels(as.factor(dati[,parent]))))
  dimnames[[length(dimnames)+1]]=levels(as.factor(dati[,parent]))
}
MAT=array(0,dim=dimvec,dimnames=dimnames)
  
meaning_mat=t(data.frame(sapply(meaning_zStates,strsplit,split="/")))
colnames(meaning_mat)=rev(dag$nodes[[i]]$parents)
rownames(meaning_mat)=NULL

for(id_row in 1:dim(meaning_mat)[1]){
  meaning_mat[id_row,]
  stringa="MAT["
  for(d in 2:length(dim(MAT))){
    id=which(dimnames(MAT)[[d]]==meaning_mat[id_row,length(dim(MAT))-d+1])
    stringa=paste(stringa, id, sep=",")
  }
  stringa=paste(stringa,"] = theta[,id_row]",sep="")
  eval(parse(text=stringa))
}

return(MAT)
}
